<?php
/**
 * Copyright (©) 2020 Pinpoint Designs LTD. All right's reserved.
 *
 * @category    Pinpoint
 * @copyright   Copyright (c) 2020 Pinpoint Designs. (http://www.pinpointdesigns.co.uk)
 * @author      Daniel Cuevas <daniel@pinpointdesigns.co.uk>
 */

namespace Pinpoint\DropShipping\Block\Adminhtml\Order\View\Tab;

/**
 * Class DropShipItem
 */
class Dropship extends \Magento\Framework\View\Element\Text\ListText implements
    \Magento\Backend\Block\Widget\Tab\TabInterface
{
    /**
     * Template
     *
     * @var string
     */
//    protected $_template = 'order/view/tab/dropship_items.phtml';

    /**
     * Core registry
     *
     * @var \Magento\Framework\Registry
     */
    protected $coreRegistry = null;

    /**
     * @param \Magento\Backend\Block\Template\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $registry,
        array $data = []
    ) {
        $this->coreRegistry = $registry;
        parent::__construct($context, $data);
    }

    /**
     * Retrieve order model instance
     *
     * @return \Magento\Sales\Model\Order
     */
    public function getOrder()
    {
        return $this->coreRegistry->registry('current_order');
    }

    /**
     * {@inheritdoc}
     */
    public function getTabLabel()
    {
        return __('Dropship');
    }

    /**
     * {@inheritdoc}
     */
    public function getTabTitle()
    {
        return __('Dropship');
    }

    /**
     * {@inheritdoc}
     */
    public function canShowTab()
    {
        // For me, I wanted this tab to always show
        // You can play around with the ACL settings
        // to selectively show later if you want
        return true;
    }

    /**
     * {@inheritdoc}
     */
    public function isHidden()
    {
        // For me, I wanted this tab to always show
        // You can play around with conditions to
        // show the tab later
        return false;
    }

    /**
     * Get Tab Class
     *
     * @return string
     */
//    public function getTabClass()
//    {
//        // I wanted mine to load via AJAX when it's selected
//        // That's what this does
//        return 'ajax only';
//    }

    /**
     * Get Class
     *
     * @return string
     */
//    public function getClass()
//    {
//        return $this->getTabClass();
//    }

    /**
     * Get Tab Url
     *
     * @return string
     */
//    public function getTabUrl()
//    {
        // customtab is a adminhtml router we're about to define
        // the full route can really be whatever you want
//        return $this->getUrl('pinpoint_dropshipping/dropship/tab', ['_current' => true]);
//    }
}
