<?php
/**
 * Copyright (©) 2020 Pinpoint Designs LTD. All right's reserved.
 *
 * @category    Pinpoint
 * @copyright   Copyright (c) 2020 Pinpoint Designs. (http://www.pinpointdesigns.co.uk)
 * @author      Daniel Cuevas <daniel@pinpointdesigns.co.uk>
 */

namespace Pinpoint\DropShipping\Block\Adminhtml\Xtento\Profile\Edit\Tab;

/**
 * Class General
 */
class General extends \Xtento\OrderExport\Block\Adminhtml\Profile\Edit\Tab\General
{
    protected $supplierCollectionFactory;

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Data\FormFactory $formFactory,
        \Magento\Config\Model\Config\Source\Yesno $yesNo,
        \Pinpoint\DropShipping\Model\ResourceModel\Supplier\CollectionFactory $collection,
        \Xtento\OrderExport\Model\System\Config\Source\Export\Entity $exportEntity,
        \Xtento\OrderExport\Helper\Entity $entityHelper,
        array $data = [])
    {
        parent::__construct($context, $registry, $formFactory, $yesNo, $exportEntity, $entityHelper, $data);
        $this->supplierCollectionFactory = $collection;
    }

    protected function _prepareForm()
    {
        parent::_prepareForm();

        $fieldset = $this->getForm()->getElement('base_fieldset');

        $fieldset->addField(
            'supplier_id',
            'select',
            [
                'label' => __('Supplier'),
                'name' => 'supplier_id',
                'values' => $this->getAllOptions(),
                'required' => false,
                'note' => __(
                    'This is only required for supplier specific order exports'
                )
            ]
        );

        //ToDo: set other values from supplier if set...

        $model = $this->_coreRegistry->registry('orderexport_profile');
        $this->getForm()->setValues($model->getData());

        return $this;
    }

    public function getAllOptions()
    {
        $emptyOption = [['label' => 'Select a Supplier', 'value' => '']];
        $this->_options = array_merge($emptyOption, $this->supplierCollectionFactory->create()->toOptionArray());
        return $this->_options;
    }
}
