<?php declare(strict_types=1);

namespace Pinpoint\DropShipping\Ui\Component\Listing\Column;

class DropshipActions extends \Magento\Ui\Component\Listing\Columns\Column
{
    protected $urlBuilder;
    const URL_PATH_DELETE = 'pinpoint_dropshipping/dropship/delete';

    /**
     * @param \Magento\Framework\View\Element\UiComponent\ContextInterface $context
     * @param \Magento\Framework\View\Element\UiComponentFactory $uiComponentFactory
     * @param \Magento\Framework\UrlInterface $urlBuilder
     * @param array $components
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\UiComponent\ContextInterface $context,
        \Magento\Framework\View\Element\UiComponentFactory $uiComponentFactory,
        \Magento\Framework\UrlInterface $urlBuilder,
        array $components = [],
        array $data = []
    ) {
        $this->urlBuilder = $urlBuilder;
        parent::__construct($context, $uiComponentFactory, $components, $data);
    }

    /**
     * Prepare Data Source
     *
     * @param array $dataSource
     * @return array
     */
    public function prepareDataSource(array $dataSource)
    {
        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as & $item) {
                if (isset($item['dropshipitem_id'])) {
                    $item[$this->getData('name')] = [
                        'delete' => [
                            'href' => $this->urlBuilder->getUrl(
                                static::URL_PATH_DELETE,
                                [
                                    'dropshipitem_id' => $item['dropshipitem_id'],
                                    'order_id' => $item['order_id']
                                ]
                            ),
                            'label' => __('Un-dropship'),
                            'confirm' => [
                                'title' => __('Undropship Item'),
                                'message' => __('Are you sure you wan\'t to undroship this item?')
                            ]
                        ]
                    ];
                }
            }
        }

        return $dataSource;
    }
}
